---
title: "Release v0.24.5"
linkTitle: "Release v0.24.5"
date: 2022-01-27
description: >
 Release v0.24.5
---

## Changelog since v0.24.0

### Notable Changes

* Add a new pipectl command to rename multiple application configuration files ([#3125](https://github.com/pipe-cd/pipecd/pull/3125))
* Enable to update application configuration filename via edit application form ([#3121](https://github.com/pipe-cd/pipecd/pull/3121))
* EventWatcher no longer tries to process failing events indefinitely ([#3065](https://github.com/pipe-cd/pipecd/pull/3065))
* Remote-upgrade and remote-config features are now at Beta status ([#3067](https://github.com/pipe-cd/pipecd/pull/3067))

### Internal Changes

* Update kapetanios to use asset-publisher:0.1.0 ([#3136](https://github.com/pipe-cd/pipecd/pull/3136))
* Upgrade dependencies for asset-publisher ([#3134](https://github.com/pipe-cd/pipecd/pull/3134))
* Remove unused build Put query ([#3133](https://github.com/pipe-cd/pipecd/pull/3133))
* Update user-guide for stable doc ([#3131](https://github.com/pipe-cd/pipecd/pull/3131))
* Fix signal stop ([#3074](https://github.com/pipe-cd/pipecd/pull/3074))
* Update user-guide for v0.24.x ([#3129](https://github.com/pipe-cd/pipecd/pull/3129))
* Disable syncing Cloud Run services in preparation for next release ([#3128](https://github.com/pipe-cd/pipecd/pull/3128))
* Remove unused Put function from DataStore interface ([#3127](https://github.com/pipe-cd/pipecd/pull/3127))
* Fix event watcher not to handle already handled events ([#3108](https://github.com/pipe-cd/pipecd/pull/3108))
* Add a new RPC to rename application configuration file ([#3120](https://github.com/pipe-cd/pipecd/pull/3120))
* Add livestatestore for Cloud Run ([#3114](https://github.com/pipe-cd/pipecd/pull/3114))
* Add collection to datastore interface ([#3113](https://github.com/pipe-cd/pipecd/pull/3113))
* Fix to pass ctx to NewStore in livestatestore ([#3116](https://github.com/pipe-cd/pipecd/pull/3116))
* Add MakeManagedByPipedLabel function for filtering Cloud Run services with label selector ([#3103](https://github.com/pipe-cd/pipecd/pull/3103))
* Update contributor list ([#3110](https://github.com/pipe-cd/pipecd/pull/3110))
* Add ServiceManifest method for handling CloudRun's services ([#3101](https://github.com/pipe-cd/pipecd/pull/3101))
* Fix to fetch additional deploys/events anytime ([#3105](https://github.com/pipe-cd/pipecd/pull/3105))
* Empower Event list to call ListEvent ([#3096](https://github.com/pipe-cd/pipecd/pull/3096))
* Change events filter to suggest possible event names ([#3093](https://github.com/pipe-cd/pipecd/pull/3093))
* Add labels getter method for ServiceManifest ([#3098](https://github.com/pipe-cd/pipecd/pull/3098))
* Add all Firestore composite indexes for Event ([#3094](https://github.com/pipe-cd/pipecd/pull/3094))
* Revert ingress to use "ImplementationSpecific" as pathType since "Prefix" is not being supported by old controllers ([#3099](https://github.com/pipe-cd/pipecd/pull/3099))
* Fix wrong proto package name for helloworld service ([#3097](https://github.com/pipe-cd/pipecd/pull/3097))
* Refactor to use early return pattern ([#3095](https://github.com/pipe-cd/pipecd/pull/3095))
* Ensure to refresh labels on the deploys/apps filter ([#3092](https://github.com/pipe-cd/pipecd/pull/3092))
* Add builtin labels for Cloud Run ([#3085](https://github.com/pipe-cd/pipecd/pull/3085))
* Add a Firestore composite index for Event ([#3089](https://github.com/pipe-cd/pipecd/pull/3089))
* Add description for AWS Lambda/ECS credentialsFile ([#3058](https://github.com/pipe-cd/pipecd/pull/3058))
* Empower WebAPI to list events ([#3077](https://github.com/pipe-cd/pipecd/pull/3077))
* Add list services interface for Cloud Run ([#3075](https://github.com/pipe-cd/pipecd/pull/3075))
* Grant all roles access to ListEvents ([#3084](https://github.com/pipe-cd/pipecd/pull/3084))
* Add event list components that rely on dummy data ([#3073](https://github.com/pipe-cd/pipecd/pull/3073))
* Make jest packages up-to-date ([#3078](https://github.com/pipe-cd/pipecd/pull/3078))
* Change timeout for AddApplicationDrawer test to 50000ms ([#3079](https://github.com/pipe-cd/pipecd/pull/3079))
* Fix ECSRunGetter interface return value ([#3076](https://github.com/pipe-cd/pipecd/pull/3076))
* Add WebAPI.ListEventsRequest that does nothing yet ([#3069](https://github.com/pipe-cd/pipecd/pull/3069))
* Fix EventStore to set UpdatedAt ([#3070](https://github.com/pipe-cd/pipecd/pull/3070))
* Fix the insecure parameter in piped's manifest ([#3072](https://github.com/pipe-cd/pipecd/pull/3072))
* Fix broken links due to change of repository name ([#3061](https://github.com/pipe-cd/pipecd/pull/3061))
* Bump Node on CI to v16.13.1 ([#3064](https://github.com/pipe-cd/pipecd/pull/3064))
* Add Diff function for Cloud Run drift detector ([#3056](https://github.com/pipe-cd/pipecd/pull/3056))
* Re-enable code coverage ([#3060](https://github.com/pipe-cd/pipecd/pull/3060))
* Migrage all gPRC requests to new path schema ([#3046](https://github.com/pipe-cd/pipecd/pull/3046))
* Add bazel-pipecd to gitignore ([#3057](https://github.com/pipe-cd/pipecd/pull/3057))
* Fix unable to run expose generated files command ([#3054](https://github.com/pipe-cd/pipecd/pull/3054))
* Fix the link to server source code ([#3053](https://github.com/pipe-cd/pipecd/pull/3053))
